// xrubik    started Nov 3, 2005
//           basic version 1.0 completed Nov 4, 2005
//                 version 1.1 completed Aug 15, 2010
//                 version 1.2 completed July 19, 2011
//
// Thanks to Ch. Tronche for getting me started with X11
// Programmed by Mark Longridge

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h> // Every Xlib program must include this
#include <X11/keysym.h>
#include <assert.h>   // I include this to test return values the lazy way
#include <unistd.h>   // So we got the profile for 10 seconds
#include <math.h>

#define NIL (0)       // A name for the void pointer

#define ScreenSizeX 400
#define ScreenSizeY 240

#define VERSION "1.2"

#define D 3    /* Cube is size '3' */
#define SIDES 6

#define SIZE_X 15
#define SIZE_Y 16
#define SEP_X  15
#define SEP_Y  16

#define TOP   0
#define DOWN  5
#define FRONT 2
#define BACK  4
#define LEFT  1
#define RIGHT 3

unsigned short c;

short d=3;
short q[SIDES][D][D], q1[SIDES][D][D];
short s1, s2, s3, s4;
short ss[SIDES];                   /* Pointers for cube placement */
short tt[SIDES];
short posx[SIDES][D];
short posy[SIDES][D];
short size_x, size_y, sep_x, sep_y;

Display *dpy;
Window w;
GC gc;
KeySym ks;
Pixmap m;

static Atom wm_delete_window;

int xp, yp;
int flag, flag_help;
int a;

int whiteColor, blackColor, thescreen;

double x,y,t,s;
double x2, y2;

char text[255];		/* a char buffer for KeyPress Events */
char version[20];       /* store version number */

XColor col[10];

XColor white, red, yellow, orange, green, blue, grey;
XColor purple, brown, pink, cyan, beige, magenta;
XColor darkgreen, darkred, darkblue, darkgrey;
XColor violet, gold, lightgreen, turquoise;

Colormap thecolormap;

void drawit(int l);
void top();
void down();
void left();
void right();
void front();
void back();
void cube_left();
void cube_right();
void cube_up();
void cube_down();
void slice_hort();
void slice_vert();
void refresh_image();
void initial_sides();
void rotate_face(short z, short dir);
void calc_cube();
void initial_pts();
void reset_size();

void initial_pts()
{
	ss[0] =1;       tt[0] =0;
	ss[1] =0;       tt[1] =1;
	ss[2] =1;       tt[2] =1;
	ss[3] =2;       tt[3] =1;
	ss[4] =3;       tt[4] =1;
	ss[5] =1;       tt[5] =2;
}

void reset_size()
{
	initial_sides ();
	refresh_image ();
}

void mix()
{
	short x;
	srand (time(NULL));
	for (x=0; x<=20; x++)
	{
		/* Choose a random number */
		c = rand() % SIDES;
		
		switch (c)
		{
			case 0:
				top();
				break;
			case 1:
				down();
				break;
			case 2:
				left();
				break;
			case 3:
				right();
				break;
			case 4:
				front();
				break;
			case 5: 
				back();
				break;
		}
	}
}	

void top()
{
	short y,z;
	z = TOP;
	rotate_face(z, 0);

	for (y=0; y<=d-1; y++)
	{
		q[LEFT][0][y] = q1[FRONT][0][y];
		q[BACK][0][y] = q1[LEFT][0][y];
		q[RIGHT][0][y]= q1[BACK][0][y];
		q[FRONT][0][y]= q1[RIGHT][0][y];
	}
	refresh_image();
}

void down()
{
	short y,z;
	z = DOWN;
	rotate_face (z, 0);

	for (y=0; y<=d-1; y++)
	{
		q[LEFT][d-1][y] = q1[BACK][d-1][y];
		q[BACK][d-1][y] = q1[RIGHT][d-1][y];
		q[RIGHT][d-1][y]= q1[FRONT][d-1][y];
		q[FRONT][d-1][y]= q1[LEFT][d-1][y];
	}
	refresh_image();
}

void front()
{
	short x,z;
	z = FRONT;
	rotate_face (z, 0);

	for (x=0; x<=d-1; x++)
	{
		z = 2-x;
		q[LEFT][z][d-1] = q1[DOWN][0][z];
		q[TOP][d-1][x] =  q1[LEFT][z][d-1];
		q[RIGHT][x][0] =  q1[TOP][d-1][x];
		q[DOWN][0][z]  =  q1[RIGHT][x][0];
	}
	refresh_image();
}

void back()
{
	short x,z;
	z = BACK;
	rotate_face (z, 0);

	for (x=0; x<=d-1; x++)
	{
		z = 2-x;
		q[LEFT][x][0] = q1[TOP][0][z];
		q[TOP][0][x] =   q1[RIGHT][x][2];
		q[RIGHT][x][2]= q1[DOWN][d-1][z];
		q[DOWN][d-1][x]=q1[LEFT][x][0];
	}
	refresh_image();
}

void left ()
{
	short x,z;
	z = LEFT;
	rotate_face (z, 0);

	for (x=0; x<=d-1; x++)
	{
		z = 2-x;
		q[TOP][x][0] =   q1[BACK][z][d-1];
		q[FRONT][x][0] = q1[TOP][x][0];
		q[DOWN][x][0] =  q1[FRONT][x][0];
		q[BACK][x][d-1] =q1[DOWN][z][0];
	}
	refresh_image();
}

void right ()
{
	short x,z;
	z = RIGHT;
	rotate_face (z, 0);

	for (x=0; x<=d-1; x++)
	{
		z= 2-x;
		q[TOP][x][d-1]   = q1[FRONT][x][d-1];
		q[FRONT][x][d-1] = q1[DOWN][x][d-1];
		q[DOWN][x][d-1]  = q1[BACK][z][0];
		q[BACK][x][0]    = q1[TOP][z][2];
	}
	refresh_image();
}


void cube_left ()
{
	short x,y,z;
	short dir=0;

	for (x=0; x<=d-1; x++)
	{
		for (y=0; y<=d-1; y++)
		{
			q[LEFT][x][y]  = q1[FRONT][x][y];
			q[FRONT][x][y] = q1[RIGHT][x][y];
			q[RIGHT][x][y] = q1[BACK][x][y];
			q[BACK][x][y]  = q1[LEFT][x][y];
		}
	}
	refresh_image (q, q1);

	z = TOP;
	rotate_face(z, dir);
	z = DOWN;
	dir =1;
	rotate_face(z, dir);
}

void cube_right ()
{
	short x,y,z;
	short dir=1;    /* Next rotation will be counter-clockwise */

	for (x=0; x<=d-1; x++)
	{
		for (y=0; y<=d-1; y++)
		{
			q[LEFT][x][y]  = q1[BACK][x][y];
			q[FRONT][x][y] = q1[LEFT][x][y];
			q[RIGHT][x][y] = q1[FRONT][x][y];
			q[BACK][x][y]  = q1[RIGHT][x][y];
		}
	}
	refresh_image (q, q1);

	z = TOP;
	rotate_face(z, dir);
	z = DOWN;
	dir =0;    /* Set direction back to clockwise */
	rotate_face(z, dir);
}

void cube_up ()
{
	short x,y,z,w;
	short dir=1;

	for (x=0; x<=d-1; x++)
	{
		z = d-1-x;
		for (y=0; y<=d-1; y++)
		{
			w = d-1-y;
			q[TOP][x][y]  =  q1[FRONT][x][y];
			q[FRONT][x][y] = q1[DOWN][x][y];
			q[DOWN][x][y] =  q1[BACK][z][w];
			q[BACK][z][w]  = q1[TOP][x][y];
		}
	}
	refresh_image (q, q1);

	z = LEFT;
	rotate_face(z, dir);
	z = RIGHT;
	dir =0;
	rotate_face(z, dir);
}

void cube_down ()
{
	short x,y,z,w;
	short dir=0;

	for (x=0; x<=d-1; x++)
	{
		z= d-1-x;
		for (y=0; y<=d-1; y++)
		{
			w = d-1-y;
			q[TOP][x][y]  =  q1[BACK][z][w];
			q[FRONT][x][y] = q1[TOP][x][y];
			q[DOWN][x][y] =  q1[FRONT][x][y];
			q[BACK][z][w]  = q1[DOWN][x][y];
		}
	}
	refresh_image (q, q1);

	z = LEFT;
	rotate_face(z, dir);
	z = RIGHT;
	dir =1;
	rotate_face(z, dir);
}

/* This is M_L */
void slice_hort()
{
        short x,z;
        short sl;

        sl=1;

        for (x=0; x<=d-1; x++)
        {
                q[FRONT][sl][x]  = q1[LEFT][sl][x];
                q[LEFT][sl][x]   = q1[BACK][sl][x];
                q[BACK][sl][x]  = q1[RIGHT][sl][x];
                q[RIGHT][sl][x]  = q1[FRONT][sl][x];
        }
        refresh_image (q, q1);
}

/* This is M_U */
void slice_vert()
{
	short x,y,z;
        short sl;

        sl=1;
	y=1;

	for (x=0; x<=d-1; x++)
	{
		z= d-1-x;
		q[FRONT][x][sl] = q1[TOP][x][sl];
		q[TOP][x][sl]   = q1[BACK][z][y];
		q[BACK][z][y]  = q1[DOWN][x][sl];
		q[DOWN][x][sl]  = q1[FRONT][x][sl];
	}
	refresh_image (q, q1);
}

void twist_corner ()
{
	q[RIGHT][1][1] = q1[TOP][1][1];
	q[FRONT][1][1] = q1[RIGHT][1][1];
	q[TOP][1][1]   = q1[FRONT][1][1];

	q[RIGHT][0][0] = q1[TOP][2][2];
	q[FRONT][0][2] = q1[RIGHT][0][0];
	q[TOP][2][2]   = q1[FRONT][0][2];

	q[RIGHT][1][0] = q1[TOP][1][2];
	q[FRONT][0][1] = q1[RIGHT][1][0];
	q[TOP][1][2]   = q1[FRONT][0][1];

	q[RIGHT][0][1] = q1[TOP][2][1];
	q[FRONT][1][2] = q1[RIGHT][0][1];
	q[TOP][2][1]   = q1[FRONT][1][2];

	refresh_image (q, q1);
}


void refresh_image()
{
	short x,y,z;
	for (z=0; z<=SIDES-1; z++)
		for (x=0; x<=d-1; x++)
			for (y=0; y<=d-1; y++)
				q1[z][x][y] = q[z][x][y];
}

void initial_sides()
{
	short x,y,z;
	for (z=0; z<=SIDES-1; z++)
		for (x=0; x<=d-1; x++)
			for (y=0; y<=d-1; y++)
				q[z][x][y] = z;
}

void calc_cube()
{
	short x,y;
	short s,t;
	short offset_x, offset_y;

	short c;

        c=0;
	offset_y=0;
	offset_x=20;

	for (s=0; s<=2; s++)
	{
		for (t=0; t<=1; t++)
		{
			for (x=0; x<= d-1; x++)
			{
			posy[c][x] = size_y*x+(tt[c]*(sep_x+(size_y*(d-2))))+offset_y;
				for (y=0; y<= d-1; y++)
				{
				   posx[c][y] = size_x*y+(ss[c]*(sep_y+(size_x*(d-2))))+offset_x;
				}
			}
			c++;
		}
	}
}

void rotate_face(short z, short dir)
{
	short x,y;
	short s1,s2,s3,s4,s5;

	for (x=0; x<=d-1; x++)
	{
		for (y=0; y<=d-1; y++)
		{
			s1=y;
			s2=x;
			s3=d-1-x;
			s4=y;
			s5=d-1-y;
			if (dir == 0)
			{
				q[z][s1][s2] = q1[z][s3][s4];
			}
			else if (dir == 1)
			{
				q[z][s3][s4] = q1[z][s1][s2];
			}
			else if (dir == 2)
			{
				q[z][s1][s2] = q1[z][s5][s3];
			}

		}
	}
	refresh_image (q, q1);
}

void drawit(int l)
{
	short x,y,z,c;
	int tempx, tempy;
        int rc;
	unsigned short s,t;
	unsigned int sizex, sizey;
        unsigned int offset_x, offset_y;

	c=0;
        offset_x = 10;
        offset_y = 20;
        sizex=30;
        sizey=20;

         for (s=0; s<=2; s++)
         {
            for (t=0; t<=1; t++)
            {
               for (x=0; x<=d-1; x++)
               {
                   for (y=0; y<=d-1; y++)
                   {
	                 XSetForeground (dpy, gc, col[q[c][x][y]].pixel);    
                         tempx = sizex*y+(ss[c]*(65+(sizex*(d-2))))+offset_x;
                         tempy = sizey*x+(tt[c]*(43+(sizey*(d-2))))+offset_y;
                         rc = XFillRectangle (dpy, m, gc, tempx, tempy, sizex, sizey);
		  }
            }
            c++;
         }
      }
      XCopyArea (dpy, m, w, gc, 0, 0, ScreenSizeX, ScreenSizeY, 0, 0);
      XFlush(dpy);
}

void help()
{
      if (flag_help == 1)
           XSetStandardProperties(dpy,w,"m = mix, q = quit","Hi",None,NULL,0,NULL);
      else
           XSetStandardProperties(dpy,w,version,"Hi",None,NULL,0,NULL);
}
      

void init_x()
{
      // Open the display

      dpy = XOpenDisplay(NIL);
      if (dpy == NULL)
      {
          fprintf(stderr, "Can't open display.\n");
          exit(1);
      }

      assert(dpy);

      // Get some colors

      blackColor = BlackPixel(dpy, DefaultScreen(dpy));
      whiteColor = WhitePixel(dpy, DefaultScreen(dpy));

      // Create the window

      w = XCreateSimpleWindow(dpy, DefaultRootWindow(dpy), 0, 0, 
				     ScreenSizeX, ScreenSizeY, 0, blackColor, blackColor);

      XSetStandardProperties(dpy,w,version,"Hi",None,NULL,0,NULL);

      // We want to get MapNotify events

      XSelectInput(dpy, w, StructureNotifyMask | ExposureMask | KeyPressMask | ButtonPressMask);

      // "Map" the window (that is, make it appear on the screen)

      XClearWindow (dpy, w);
      XMapWindow(dpy, w);
      wm_delete_window = XInternAtom(dpy, "WM_DELETE_WINDOW", False);
      XSetWMProtocols(dpy, w, &wm_delete_window, 1);


      // Create a "Graphics Context"

      gc = XCreateGC(dpy, w, 0, NIL);

      thescreen   = DefaultScreen(dpy);
      thecolormap = DefaultColormap(dpy,thescreen);
      
      m = XCreatePixmap (dpy, w, ScreenSizeX, ScreenSizeY, DefaultDepth(dpy, thescreen)); 

      XAllocNamedColor(dpy, thecolormap, "white", &white, &col[0]);       
      XAllocNamedColor(dpy, thecolormap, "red", &red, &col[1]);             
      XAllocNamedColor(dpy, thecolormap, "yellow", &yellow, &col[2]);          
      XAllocNamedColor(dpy, thecolormap, "orange", &orange, &col[3]);    
      XAllocNamedColor(dpy, thecolormap, "green", &green, &col[4]);       
      XAllocNamedColor(dpy, thecolormap, "blue", &blue, &col[5]);    
      XAllocNamedColor(dpy, thecolormap, "grey", &grey, &col[6]);    

      XSetForeground (dpy, gc, grey.pixel);
      XFillRectangle (dpy, m, gc, 0, 0, ScreenSizeX, ScreenSizeY); 
}

deal_with_keys(event)
XKeyEvent *event;
{
   int count;
   int buffer_size = 80;
   char buffer[80];
   KeySym keysym;

   count = XLookupString(event,buffer,buffer_size, &keysym);

   if ((keysym >= XK_space) && (keysym <= XK_asciitilde))
   {
      if (event->state & ShiftMask)
      {
          if (buffer[0] == XK_asterisk)
          {
             reset_size();
             drawit(1);
          }
      }
      else if (buffer[0] == XK_t || buffer[0]== XK_u)
      {
          top();
          drawit(1);
      }
      else if (buffer[0] == XK_d)
      {
          down();
          drawit(1);
      }
      else if (buffer[0] == XK_l)
      {
          left();
          drawit(1);
      }    
      else if (buffer[0] == XK_r)
      {
          right();
          drawit(1);
      }    
      else if (buffer[0] == XK_f)
      {
          front();
          drawit(1);
      }
      else if (buffer[0] == XK_m)
      {
          mix();
          drawit(1);
      }
      else if (buffer[0] == XK_b)
      {
          back();
          drawit(1);
      }
      else if (buffer[0] == XK_h)
      {
          flag_help ^=1;
          help();
          drawit(1);
      }
      else if (buffer[0] == XK_q)
      {	      
          flag=1;
      }
      else if (buffer[0] == XK_equal)
      {
	  slice_hort();
	  drawit(1);
      }
      else if (buffer[0] == XK_minus)
      {
          slice_vert();
          drawit(1);
      }
      else if (buffer[0] == XK_z)
      {
          twist_corner();
          drawit(1);
      }
   }
   else if (keysym == XK_Right)
   {
        cube_right();
        drawit(1);
   }
   else if (keysym == XK_Left)
   {
        cube_left();
        drawit(1);
   }
   else if (keysym == XK_Up)
   {
        cube_up();
        drawit(1);
   }
   else if (keysym == XK_Down)
   {
        cube_down();
        drawit(1);
   }
   else if (keysym == XK_KP_Multiply)
   {
        reset_size();
        drawit(1);
   }
   else if (keysym == XK_Return)
   {
        printf ("\nEnter key pressed\n");
   }
}

main()
{
      /* Set up the attributes of the window */

      strcpy (version, "xrubik version ");
      strcat (version, VERSION);

      init_x();

      size_x = SIZE_X;
      size_y = SIZE_Y;
      sep_x = SEP_X;
      sep_y = SEP_Y;

      initial_pts();
      initial_sides ();
      refresh_image ();
      calc_cube();
      

      flag = 0;
      flag_help =0;

      /* Wait for the MapNotify event */
      while (flag == 0) 
      {
	    XEvent e;
	    XNextEvent(dpy, &e);

	    switch (e.type)
	    {
		    case Expose:
                        XSetForeground(dpy, gc, whiteColor);
	                drawit(1);
			break;
		    case MapNotify:
	                break;
		    case KeyPress:
                        deal_with_keys(&e);
			break;
	            case ButtonPress:
			if (e.xbutton.button == 1)
				          printf("Left mouse button pressed\n");
			break;

			/* This is necessary to exit gracefully when you click out using the mouse */
		    case ClientMessage:
		        if ((Atom)e.xclient.data.l[0] == wm_delete_window) 
			{
				flag=1;
			}
			break;
	    }
      }
      /*
      XBell(dpy, 100);
      */
      
      XFreeGC(dpy, gc);
      XDestroyWindow (dpy, w);
      XFreePixmap (dpy, m);
      XCloseDisplay(dpy);
}
